<?php

namespace ebay\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for AverageRatingDetailArrayType ArrayType
 * Meta informations extracted from the WSDL
 * - documentation: This type has been deprecated.
 * @subpackage Arrays
 * @date 2017-04-07 16
 */
class AverageRatingDetailArrayType extends AbstractStructArrayBase
{
    /**
     * The AverageRatingDetails
     * Meta informations extracted from the WSDL
     * - documentation: This field is deprecated.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \ebay\StructType\AverageRatingDetailsType[]
     */
    public $AverageRatingDetails;
    /**
     * Constructor method for AverageRatingDetailArrayType
     * @uses AverageRatingDetailArrayType::setAverageRatingDetails()
     * @param \ebay\StructType\AverageRatingDetailsType[] $averageRatingDetails
     */
    public function __construct(array $averageRatingDetails = array())
    {
        $this
            ->setAverageRatingDetails($averageRatingDetails);
    }
    /**
     * Get AverageRatingDetails value
     * @return \ebay\StructType\AverageRatingDetailsType[]|null
     */
    public function getAverageRatingDetails()
    {
        return $this->AverageRatingDetails;
    }
    /**
     * Set AverageRatingDetails value
     * @throws \InvalidArgumentException
     * @param \ebay\StructType\AverageRatingDetailsType[] $averageRatingDetails
     * @return \ebay\ArrayType\AverageRatingDetailArrayType
     */
    public function setAverageRatingDetails(array $averageRatingDetails = array())
    {
        foreach ($averageRatingDetails as $averageRatingDetailArrayTypeAverageRatingDetailsItem) {
            // validation for constraint: itemType
            if (!$averageRatingDetailArrayTypeAverageRatingDetailsItem instanceof \ebay\StructType\AverageRatingDetailsType) {
                throw new \InvalidArgumentException(sprintf('The AverageRatingDetails property can only contain items of \ebay\StructType\AverageRatingDetailsType, "%s" given', is_object($averageRatingDetailArrayTypeAverageRatingDetailsItem) ? get_class($averageRatingDetailArrayTypeAverageRatingDetailsItem) : gettype($averageRatingDetailArrayTypeAverageRatingDetailsItem)), __LINE__);
            }
        }
        $this->AverageRatingDetails = $averageRatingDetails;
        return $this;
    }
    /**
     * Add item to AverageRatingDetails value
     * @throws \InvalidArgumentException
     * @param \ebay\StructType\AverageRatingDetailsType $item
     * @return \ebay\ArrayType\AverageRatingDetailArrayType
     */
    public function addToAverageRatingDetails(\ebay\StructType\AverageRatingDetailsType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \ebay\StructType\AverageRatingDetailsType) {
            throw new \InvalidArgumentException(sprintf('The AverageRatingDetails property can only contain items of \ebay\StructType\AverageRatingDetailsType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AverageRatingDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \ebay\StructType\AverageRatingDetailsType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \ebay\StructType\AverageRatingDetailsType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \ebay\StructType\AverageRatingDetailsType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \ebay\StructType\AverageRatingDetailsType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \ebay\StructType\AverageRatingDetailsType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AverageRatingDetails
     */
    public function getAttributeName()
    {
        return 'AverageRatingDetails';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ebay\ArrayType\AverageRatingDetailArrayType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
